C rho(sigma) FOR THREE BODY RESONANCES - TABARE GALLARDO 2013
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 KGAUS,KG2
      DIMENSION SE(10),SM(10),SN(10)
      COMMON SE,SM,SN
      TWOPI = 8.0D0*DATAN(1.0D0)
      CERO  = 0.0D0
      UNO   = 1.0D0
      PI=TWOPI/2.D0
      G2R=PI/180.D0
      DOST=2.D0/3.D0
      KGAUS=0.01720209895D0
      KG2=KGAUS**2
C MEAN SEMIMAJOR AXIS
C DEFINED AS THE a THAT GENERATES THE MEAN MOTION n EQUAL TO THE OBSERVED
C dlambda/dt IN THE NUMERICAL INTEGRATIONS OF THE FULL PLANETART SYSTEM
C BEING lambda = varpi + mean anomaly
      SE(1)=  0.387099D0
      SE(2)=  0.723332D0
      SE(3)=  1.000000D0
      SE(4)=  1.523692D0
      SE(5)=  5.20281D0
      SE(6)=  9.53882D0
      SE(7)= 19.1831D0
      SE(8)= 30.0556D0
C UNIT = M_jup * k^2
      SMASAJUP=9.54791938D-04*KG2
C MASS TO BE USED IN CALCULATION OF MEAN MOTIONS
      SM(1)=1.66013679D-07*KG2/SMASAJUP
      SM(2)=2.44783833D-06*KG2/SMASAJUP
      SM(3)=3.04043264D-06*KG2/SMASAJUP
      SM(4)=3.22715144D-07*KG2/SMASAJUP
      SM(5)=9.54791938D-04*KG2/SMASAJUP
      SM(6)=2.85885980D-04*KG2/SMASAJUP
      SM(7)=4.36624404D-05*KG2/SMASAJUP
      SM(8)=5.15138902D-05*KG2/SMASAJUP


      WRITE(*,*)'------------------------------------------------------'
      WRITE(*,*)'  This program evaluates rho(sigma) and its strength  '
      WRITE(*,*)' Delta rho corresponding to a three-body resonance in'
      WRITE(*,*)'the Solar System according to Gallardo (2014, Icarus).'
      WRITE(*,*)'         www.fisica.edu.uy/~gallardo/atlas'
      WRITE(*,*)'------------------------------------------------------'
      WRITE(*,*)' '
      WRITE(*,*)' '


 100  WRITE(*,*)'indicate k0,k1,k2,planet1,planet2 (ex: 2,-5,2,5,6)'
      READ(*,*)CTE0,CTE1,CTE2,IP1,IP2
C ORBITAL ELEMENTS OF THE PARTICLE
 101  WRITE(*,*)'e,i,argper for the particle? (ex: 0.3,35,127)'
      READ(*,*)EXC,YNCLINA,ARG
C PLANETARY MEAN MOTIONS, KGAUSS=1
      DO I=1,8
        SN(I)=DSQRT((1.D0+SM(I)/(KG2/SMASAJUP))/SE(I)**3)
      ENDDO
      AMM=-(CTE1*SN(IP1)+CTE2*SN(IP2))/CTE0
C MEAN MOTION MUST BE POSITIVE
      IF(AMM.LE.0.D0) THEN
        WRITE(*,*) 'ERROR: a LESS THAN 0 !!'
        GOTO 100
      ENDIF
      SEM=AMM**(-DOST)
      WRITE(*,*) 'a = ',sem
      A0=SEM
      ARGPER=ARG*G2R
      YNC=YNCLINA*G2R
      E0=EXC
      WRITE(*,*)'CALCULATING...'
      CALL FUERZA3(I,A0,IP1,IP2,CTE0,CTE1,CTE2,ARGPER,YNC,E0,fme,FUE)
      OPEN(1,FILE='aeiwdr.dat', STATUS='UNKNOWN', ACCESS='APPEND')
      WRITE(1,33) A0, EXC, YNCLINA, ARG, FUE
      CLOSE(1)
      GOTO 101
 33   FORMAT(F12.5,F6.3,2F6.1,E14.4)
      STOP
      END
C ==================================================================
C CALCULATION OF THE STRENGTHS ACCORDING TO TABARE GALLARDO 2013
      SUBROUTINE FUERZA3(IRESO,A0,IP1,IP2,CTE0,CTE1,CTE2,ARGPER,J0,E0,
     *FME,FUE)
      IMPLICIT REAL*8 (A-H,J-Z)
      DIMENSION SE(10),SM(10),SN(10)
      DIMENSION RP(400)
      REAL*4 RPG(400),SIGMA(400),YMAX
      COMMON SE,SM,SN
      CERO  = 0.0D0
      UNO   = 1.0D0
      KGAUS=0.01720209895D0
      KG2=KGAUS**2
      TWOPI = 8.0D0*DATAN(1.0D0)
      PI=TWOPI/2.D0
      G2R=PI/180.D0
      ERROR=1.D-12
      IPOR=50
      POR=DFLOAT(IPOR)
C ORDER
      SUC=CTE0+CTE1+CTE2
      A1=SE(IP1)
      A2=SE(IP2)
C NUMBER OF EVALUATIONS OF RHO(SIGMA) BETWEEN O AND 360
C FOR MORE PRECISTION USE MORE POINTS
      ISIMAX=36
C STEPS OF THE NUMERICAL INTEGRATION
C FOR MORE PRECITION USE MORE POINTS
      IPASOS=180
C SIGMA = CRITICAL ANGLE
      DO 900 ISI=1,ISIMAX+1
C TETA IS SIGMA
        TETA=DFLOAT(ISI-1)/DFLOAT(ISIMAX)*360.D0
C TO RADIANS
        TETAR=TETA*G2R
C 0 IS THE PARTICLE
C 1 IS PLANET P1
C 2 IS PLANET P2
C INTEGRAL IN LAMBDA0, INTEGRAL IN LAMBDA1
        RTOT=CERO
        DELTAAM0=TWOPI/DFLOAT(IPASOS)
        AM0=-DELTAAM0
        DO 901 IMEDIA0=1,IPASOS
C PARTICLE IN A FIXED POSITION
          AM0=AM0+DELTAAM0
C ASSUME LONG NODE=0 THEN LONGPER=ARGPER
          L0=0.D0
          P0=ARGPER
          LAMBDA0=AM0+P0
 222      IF (LAMBDA0.GT.TWOPI) THEN
            LAMBDA0=LAMBDA0-TWOPI
            GOTO 222
          END IF
C SOLVING KEPLER FOR PARTICLE (ECCENTRIC)
          CALL SOLKEP(E0,AM0,AEX0,IN)
C TRUE ANOMALY
          AVE0=DACOS((DCOS(AEX0)-E0)/(UNO-E0*DCOS(AEX0)))
          IF(AM0.GT.PI) AVE0=TWOPI-AVE0
C HELIOCENTRIC DISTANCE
          R0=A0*(UNO-E0*DCOS(AEX0))
C RADIUS VECTOR FOR particle
          X0=R0*(DCOS(L0)*DCOS(P0-L0+AVE0)-DSIN(L0)*DSIN(P0-L0+AVE0)
     **DCOS(J0))
          Y0=R0*(DSIN(L0)*DCOS(P0-L0+AVE0)+DCOS(L0)*DSIN(P0-L0+AVE0)
     **DCOS(J0))
          Z0=R0*DSIN(P0-L0+AVE0)*DSIN(J0)
C PLANET 1
          DELTAAM1=TWOPI/DFLOAT(IPASOS)
          AM1=-DELTAAM1
          DO 902 IMEDIA1=1,IPASOS
C LAMBDA PLANET 1
            AM1=AM1+DELTAAM1
C ASSUMING LONG PERI=0  LONG NODE=0
            P1=0.D0
            L1=0.D0
            LAMBDA1=AM1+P1
C PLANET 1 IN CIRCULAR ORBIT
            AVE1=AM1
C HELIOCENTRIC DISTANCE
            R1=A1
C RADIUS VECTOR FOR PLANET 1
            X1=R1*DCOS(P1+AVE1)
            Y1=R1*DSIN(P1+AVE1)
            Z1=0.D0
C DISTANCE ASTEROID-P1
            DELTA01=DSQRT((X1-X0)**2+(Y1-Y0)**2+(Z1-Z0)**2)
C SCALAR PRODUCT R1*R0
            R1R0=X1*X0+Y1*Y0
C  DERIV R01 / DX1  and  DERIV R01 / DY1
            DR01DX1=(X0-X1)/DELTA01**3 - X0/R1**3 + 3.D0*X1*R1R0/R1**5
            DR01DY1=(Y0-Y1)/DELTA01**3 - Y0/R1**3 + 3.D0*Y1*R1R0/R1**5
C  DERIV R01 / DX0
            DR01DX0 = (X1-X0)/DELTA01**3 - X1/R1**3
C  DERIV R01 / DY0
            DR01DY0 = (Y1-Y0)/DELTA01**3 - Y1/R1**3
C  DERIV R01 / DZ0
            DR01DZ0 = (Z1-Z0)/DELTA01**3
C PLANET 2
C LAMBDA2 IS FIXED
            LAMBDA20=(TETAR + SUC*P0 -CTE0*LAMBDA0-CTE1*LAMBDA1)/CTE2
 502        IF (LAMBDA20.GT.TWOPI) THEN
              LAMBDA20=LAMBDA20-TWOPI
              GOTO 502
            END IF
 503        IF (LAMBDA20.LT.CERO) THEN
              LAMBDA20=LAMBDA20+TWOPI
              GOTO 503
            END IF
C K2 POSSIBLE VALUES F0R LAMBDA2
            DO 903 IL=1,INT(ABS(CTE2))
              LAMBDA2=LAMBDA20 + TWOPI*DFLOAT(IL-1)/DABS(CTE2)
C ASSUMING LONG PERI=0  LONG NODE=0
              L2=0.D0
              P2=0.D0
              AM2=LAMBDA2-P2
 202          IF (AM2.GT.TWOPI) THEN
                AM2=AM2-TWOPI
                GOTO 202
              END IF
 203          IF (AM2.LT.CERO) THEN
                AM2=AM2+TWOPI
                GOTO 203
              END IF
C PLANET IN CIRCULAR ORBIT
              AVE2=AM2
C HELIOCENTRIC DISTANCE
              R2=A2
C RADIUS VECTOR FOR PLANET  2
              X2=R2*DCOS(P2+AVE2)
              Y2=R2*DSIN(P2+AVE2)
              Z2=0.D0
C DISTANCE ASTEROID-P2
              DELTA02=DSQRT((X2-X0)**2+(Y2-Y0)**2+(Z2-Z0)**2)
C SCALAR PRODUCT R2*R0
              R2R0=X2*X0+Y2*Y0
C  DERIV R02 / DX2  Y  DERIV R02 / DY2
      DR02DX2=(X0-X2)/DELTA02**3 - X0/R2**3 + 3.D0*X2*R2R0/R2**5
      DR02DY2=(Y0-Y2)/DELTA02**3 - Y0/R2**3 + 3.D0*Y2*R2R0/R2**5
C DISTANCE P1-P2
              DELTA12=DSQRT((X2-X1)**2+(Y2-Y1)**2)
C  DERIV R21 / DX2  Y  DERIV R21 / DY2
              DR21DX2=(X1-X2)/DELTA12**3 - X1/R1**3
              DR21DY2=(Y1-Y2)/DELTA12**3 - Y1/R1**3
C  DERIV R12 / DX1  Y  DERIV R12 / DY1
              DR12DX1=(X2-X1)/DELTA12**3 - X2/R2**3
              DR12DY1=(Y2-Y1)/DELTA12**3 - Y2/R2**3
C  DERIV R02 / DX0
              DR02DX0 = (X2-X0)/DELTA02**3 - X2/R2**3
C  DERIV R02 / DY0
              DR02DY0 = (Y2-Y0)/DELTA02**3 - Y2/R2**3
C  DERIV R02 / DZ0
              DR02DZ0 = (Z2-Z0)/DELTA02**3
      COSO = 2.D0*(DR02DX0*DR01DX0 + DR02DY0*DR01DY0 + DR02DZ0*DR01DZ0)
              DIRECTA = COSO
              YNDIRECTA = DR02DX2*DR21DX2 + DR02DY2*DR21DY2
      YNDIRECTA = YNDIRECTA + DR01DX1*DR12DX1 + DR01DY1*DR12DY1
              RTOT=RTOT + YNDIRECTA + DIRECTA
 903        CONTINUE
 902      CONTINUE
 901    CONTINUE
C END OF LOOP FOR LAMBDAS
C VALUE OF THE INTEGRAL
C      RTOT ASSUMING M_JUP*K^2 = 1
        RTOT=SM(IP1)*SM(IP2)*RTOT/DABS(CTE2)/DFLOAT(IPASOS)**2
C DELTA T SQR OVER 2
        DTSQ2=0.5D0*A0*A1*A2*(2.D0*PI/KGAUS)**2/DFLOAT(IPASOS)**2
C RHO(SIGMA):
        RP(ISI)=RTOT*DTSQ2
        SIGMA(ISI)=TETA
C IN STANDARD UNITS YOU MUST MULTIPLY BY (KG2*M_J)**2
C      7.982579501E-14
        OPEN(1,FILE='rhosigma.dat',STATUS='UNKNOWN',ACCESS='APPEND')
        WRITE(1,40) TETA, rp(isi)
        CLOSE(1)
 900  CONTINUE
C END OF LOOP FOR SIGMA
C ====================================================================
C CALCULATION OF MEAN VALUE <rho>
      VMEDIO=0.D0
      DO I2=1,ISIMAX
        VMEDIO=VMEDIO+RP(I2)
      ENDDO
      VMEDIO=VMEDIO/DFLOAT(ISIMAX)
C FIND rho_max AND rho_min
      VRMAX=-999999.D0
      VRMIN=999999.D0
      DO I2=1,ISIMAX
        IF(RP(I2).LT.VRMIN) THEN
          VRMIN=RP(I2)
        ENDIF
        IF(RP(I2).GT.VRMAX) THEN
          VRMAX=RP(I2)
        ENDIF
      ENDDO
      FME=VMEDIO
C      FUE=VMEDIO-VRMIN
C STRENGTH
      FUE=(VRMAX-VRMIN)/2.d0
      YMAX=VRMAX-VMEDIO
C CALCULATION OF rho - rho_min FOR PLOTTING WITH DISLIN LIBRARIES
       DO I=1,ISIMAX+1
         RPG(I)=RP(I)-VRMIN
       ENDDO
C==================================================================
C  DISLIN  START HERE
C IF YOU DONT LIKE TO COMPILE WITH DISLIN CUT HERE ---------------------
CC      call METAFL('XWIN')
C      CALL DISINI
C      CALL PAGHDR('rho(sigma) for Three Body Resonances',
C     *'T. Gallardo 2013',4,0)
C      CALL COMPLX
C      CALL NAME('sigma','X')
C      CALL NAME('rho(sigma) - rho_min','Y')
C      CALL TITLIN('rho(sigma) for Three Body Resonances',3)
C      CALL GRAF (0, 360, 30, 30, 0, ymax, ymax/4., Ymax/4.)
C      CALL QPLOT(SIGMA,RPG,ISIMAX+1)
C ----------------END DISLIN-------------------------------------------
      RETURN
 40   FORMAT(F6.1,F25.20)
      END
C ========================================================================
C SOLVING KEPLER EQUATION (Adrian Brunini)
	SUBROUTINE SOLKEP(EX,M,E,NITER)
C SOLUCION ITERATIVA DE LA ECUACION DE KEPLER
C ENTRA:EX   EXCENTRICIDAD            (<1)
C       M    ANOMALIA MEDIA           (RADIANES)
C SALE: E    ANOMALIA EXCENTRICA      (RADIANES)
C
	 IMPLICIT REAL*8 (A-H,O-Z)
	 REAL*8 M,MK
	 TOLE=1.D-11
	 DOSPI=8.D0*DATAN(1.D0)
	 M=DMOD(M,DOSPI)
	 E=M
	 NITER=0
 100     E0=E
	 SE=DSIN(E0)
	 CE=DCOS(E0)
	 ES=EX*SE
	 EC=1.D0-EX*CE
	 MK=E0-ES
	 U=(MK-M)/EC
	 XPRI=E0-U
	 XSEG=E0-U/(1.D0-U*ES)
	 E=(XPRI+XSEG)/2.D0
	 DEX=DABS(E-E0)
	 NITER=NITER+1
	 IF(NITER.GT.20)GOTO 200
	 IF(DEX.GT.TOLE)GOTO 100
	 RETURN
200      CONTINUE
	 NDIC=0
	 E0=-DOSPI
	 DE0=DOSPI/10.D0
400      DE=DE0/(10.D0**NDIC)
	 SE=DSIN(E0)
	 CE=DCOS(E0)
	 ES=EX*SE
	 EM0=E0-ES-M
	 NITER=0
300      E1=E0+DE
	 NITER=NITER+1
	 IF(NITER.GT.100)THEN
	 WRITE(*,*)'ERROR IN KEPLER'
	 RETURN
	 ENDIF
	 SE=DSIN(E1)
	 CE=DCOS(E1)
	 ES=EX*SE
	 EM1=E1-ES-M
	 IF(EM1*EM0.GT.0.D0)THEN
	 E0=E1
	 EM0=EM1
	 GOTO 300
	 ELSE
	 NDIC=NDIC+1
	 IF(NDIC.EQ.3)THEN
	 E=E1
	 RETURN
	 ENDIF
	 GOTO 400
	 ENDIF
	 RETURN
	 END
C===================================================================



